package com.ctl.validation.util;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import javax.validation.ConstraintViolation;
import javax.validation.Validation;
import javax.validation.Validator;
import javax.validation.ValidatorFactory;
import javax.validation.groups.Default;

 /*
import com.manessinger.cookbook.exception.ConstraintProperty;
import com.manessinger.cookbook.exception.ValidationException;
import com.manessinger.cookbook.exception.ViolationDetail;
 */
public class ValidationUtil {
 
    // the factory is expensive but thread-safe
    private ValidatorFactory factory = Validation.buildDefaultValidatorFactory();
    
    public boolean isValid(Object obj) throws ValidationException {
    	boolean isValid = true;
    	List<ViolationDetail> details= null;
    	
    	Validator v = factory.getValidator();
    	
    	Set<ConstraintViolation<Object>> violations = v.validate(obj, Default.class);
        System.out.println(violations.size());
        if (violations != null & !violations.isEmpty()) {
        		isValid = false;
        	 details = new ArrayList<ViolationDetail>();
        	 for (ConstraintViolation<Object> constrain:violations) {
     			System.out.println("-"+constrain.getMessage());
     			ViolationDetail detail = new ViolationDetail();
     			detail.setAttributeName(constrain.getPropertyPath().toString());
     			detail.setMessage(constrain.getMessage());
     			detail.setViolationType(constrain.getConstraintDescriptor()
                        .getAnnotation().annotationType().getSimpleName());
     			Object invalidValue = constrain.getInvalidValue();
     			detail.setInvalidValue((invalidValue != null ? 
                        invalidValue.toString() : "null"));
     			details.add(detail);
     		}
        	 throw new ValidationException(details);
        }
        return isValid;
        
    }
}
